/*
 * UCB-BF504 GP^C} LEDuNR[h
 *
 * Copyright(C) 2012 Kaneko System Co., Ltd.
 *
 * ̃TvR[hɂẮALURLQƂB
 * http://kaneko-sys.co.jp/support/
 *
 * yӁz
 * EǂȂłRɉςĎgp邱Ƃł܂B
 * Ẽ\tgEFA͖ۏ؂łB̃t@CɋLڂĂER[h
 *   gpꍇ́A[U̐ӔCɂčsĂB̎gp
 *   NA[U܂͑O҂ɐQɊւAЂ͈؂̐ӔC
 *   ܂B
 *
 */

/*
 * yz
 * ̃vÓAGP^C}0Ɗ荞݂gĎԂvAUCB-BF504
 * 1ԃs(PG1)ɐڑꂽLED0.5bɓ_ł܂B
 */

#include <blackfin.h>
#include <builtins.h>
#include <sys/exception.h>
#include <stdint.h>

/* VXeNbN(100MHz) */
#define SCLOCK_HZ		(100000000)

/* GP^C}0荞݂̃vg^Cv錾 */
EX_INTERRUPT_HANDLER(s_gptimer_isr);

/* GP^C}0荞݂ŃCNg1msJE^ */
static volatile uint32_t sf_1ms_counter = 0;

static void s_bfin_clk_pll_set(uint8_t mul_val, uint8_t div_val)
{
	*pSIC_IWR = IWR_ENABLE(0);				/* PLL̂IWR */
	*pPLL_DIV = div_val;
	*pPLL_CTL = (mul_val) << 9;
	asm("cli r0; csync; idle; sti r0;": : :"R0");
	*pSIC_IWR = IWR_ENABLE_ALL;
}

void main(void)
{
	uint32_t l_cnt_now;
	
	/* PLLݒ */
	s_bfin_clk_pll_set(16, 4);
	
	/* 荞݃nhIVG12ɓo^ */
    register_handler(ik_ivg12, s_gptimer_isr);
	*pSIC_IMASK1 |= IRQ_TIMER0;

	/* GP^C}0̐ݒ */
	/* 1msPʂɊ荞݂悤ɐݒ */
	*pTIMER0_CONFIG = OUT_DIS | IRQ_ENA | PERIOD_CNT | PWM_OUT;
	*pTIMER0_PERIOD = SCLOCK_HZ / 1000;
	*pTIMER0_WIDTH = 1;
	*pTIMER_ENABLE = TIMEN0;
	ssync();
	
	/* PG1GPIO[hɐݒ */
	*pPORTG_FER &= ~PG1;
	/* PG1o̓|[gɐݒ */
	*pPORTGIO_DIR |= PG1;
	/* LED_ */
	*pPORTGIO_CLEAR = PG1;
	ssync();

	l_cnt_now = sf_1ms_counter;
	while(1)
	{
		/* 500msPG1gO */
		if((sf_1ms_counter - l_cnt_now) >= 500)
		{
			l_cnt_now = sf_1ms_counter;
			*pPORTGIO_TOGGLE = PG1;
			ssync();
		}
		/* vZbTX[v */
		idle();
	}
}

EX_INTERRUPT_HANDLER(s_gptimer_isr)
{
	/* 荞݃Xe[^X̍XV */
	*pTIMER_STATUS = TIMIL0;
	ssync();
	
	/* JE^CNg */
	sf_1ms_counter++;
}

